﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.ComponentModel;
using System.Windows.Controls;
using System.Windows;

namespace Listener_Server_Example
{
    public class ListViewLastColExtender
    {
        ListView _listView;
        internal ListViewLastColExtender(ListView listView)
        {
            _listView = listView;

            foreach (GridViewColumn column in (listView.View as GridView).Columns)
            {
                DependencyPropertyDescriptor descriptor =
                DependencyPropertyDescriptor.FromProperty
                (GridViewColumn.WidthProperty, typeof(GridViewColumn));

                descriptor.AddValueChanged
                  (column, new EventHandler(OnColumnWidthChanged));
            }
            OnColumnWidthChanged(listView, null);
            listView.SizeChanged += new SizeChangedEventHandler(_listView_SizeChanged);
        }


        private void OnColumnWidthChanged(object sender, EventArgs e)
        {
            double width = _listView.ActualWidth;
            GridView gv = _listView.View as GridView;
            for (int i = 0; i < gv.Columns.Count - 1; i++)
            {
                if (!Double.IsNaN(gv.Columns[i].Width))
                    width -= gv.Columns[i].Width;
                else if (!Double.IsNaN(gv.Columns[i].ActualWidth))
                    width -= gv.Columns[i].ActualWidth;
            }

            width -= 6;
            if (width < 10)
                width = 10;

            gv.Columns[gv.Columns.Count - 1].Width = width;// this is to take care of margin/paddin
        }


        void _listView_SizeChanged(object sender, SizeChangedEventArgs e)
        {
            OnColumnWidthChanged(sender, e);
        }
    }
}
